
#include "stm32f1xx.h"
#include "stdlib.h"

uint32_t data_send[5];
uint32_t data_rece[5];


volatile uint8_t done;


void DMA1_CLK_Enable()
{
	RCC->AHBENR|=RCC_AHBENR_DMA1EN;
}


void DMA1_M2M_Transfer(uint32_t *src, uint32_t *dest, uint16_t len)
{

	DMA1_Channel1->CCR|=DMA_CCR_MEM2MEM|DMA_CCR_MINC|DMA_CCR_PINC|DMA_CCR_TCIE
			|DMA_CCR_MSIZE|DMA_CCR_PSIZE;

	NVIC_EnableIRQ(DMA1_Channel1_IRQn);

	DMA1_Channel1->CPAR= (uint32_t) src;

	DMA1_Channel1->CMAR= (uint32_t)dest;

	DMA1_Channel1->CNDTR = len;

	DMA1_Channel1->CCR|=DMA_CCR_EN;


}



int main(void)
{
	DMA1_CLK_Enable();

	while(1)
	{

		for(int i=0;i<5;i++)
		{
			data_send[i]=random()%256;
		}

		DMA1_M2M_Transfer(data_send,data_rece,5);

		while(done==0);
		done=0;

		for (int i=0;i<10000;i++);
	}
}

void DMA1_Channel1_IRQHandler (void)
{
	if((DMA1->ISR & DMA_ISR_TCIF1)==DMA_ISR_TCIF1)
	{
		done=1;
		DMA1->IFCR=DMA_IFCR_CTCIF1;
		DMA1_Channel1->CCR&=~DMA_CCR_EN;
	}

}
